*-----------------------------------------------------------
* Program    :TicTacToe 
* Written by :Jeff Beauman
* Date       :
* Description:Project
* Modification: June 11, 2009 (CK)
*-----------------------------------------------------------
        ORG     $1000
*Winner - d7    
*Player - d6
*Ttt    - d5
*IntX   - d4

paintBoard      macro
        lea     grid,a6

     for.b d6 = #0 to #16 by #2 do.s            clear array
       move.b   #blank,(a6,d6.w)
     endf

        move.l  #black,d1       
        move.b  #80,d0
        trap    #15     Set pen color

        move.l  #tan,d1
        move.b  #81,d0  
        trap    #15     Set fill color

        move.b  #3,d1   
        move.b  #93,d0
        trap    #15     Set pen width
        
        move.b  #17,d1  Double buffering
        move.b  #92,d0
        trap    #15     Set drawing mode

        move.w  #0,d1    0__________
        move.w  #0,d2   0|          |
        move.w  #800,d3  |          |
        move.w  #600,d4  |          |
        move.b  #87,d0    ---------- 600
        trap    #15     Draw board  8
*                                   0
        move.w  #324,d1 75          0
        move.w  #75,d2   |
        move.w  #324,d3 3|
        move.w  #525,d4 2|
        move.b  #84,d0  4|      
        trap    #15     525
        
        move.w  #474,d1         75
        move.w  #75,d2           |
        move.w  #474,d3         4|
        move.w  #525,d4         7|
        move.b  #84,d0          4|
        trap    #15             525
        
        move.w  #175,d1 1    224    6
        move.w  #224,d2 7-----------2
        move.w  #625,d3 5           5
        move.w  #224,d4
        move.b  #84,d0
        trap    #15
        
        move.w  #175,d1
        move.w  #374,d2 1    374    6
        move.w  #625,d3 7-----------2
        move.w  #374,d4 5           5
        move.b  #84,d0
        trap    #15     Draw lines
                
        move.w  #10,d1  left side
        move.w  #525,d2 top
        move.w  #139,d3 right side
        move.w  #567,d4 bottom
        move.b  #87,d0
        trap    #15     Draw new game button

        move.w  #661,d1
        move.w  #525,d2
        move.w  #790,d3
        move.w  #567,d4
        move.b  #87,d0
        trap    #15     Draw exit button

        move.l  #black,d1
        clr.l   d2
        move.b  #21,d0
        trap    #15
                
        lea     newgame,a1
        move.b  #40,d1  x
        move.w  #537,d2 y
        move.b  #95,d0
        trap    #15     Draw new game button text
        
        lea     exit,a1
        move.w  #710,d1
        move.w  #537,d2
        move.b  #95,d0
        trap    #15     Draw exit button text
        
        suba.l  a1,a1
        
        move.b  #94,d0
        trap    #15     Repaint screen
        endm
        
checkButtons    macro
        move.l  d1,-(sp)                ; save d1
        swap    d1                      d1=xxxxxxxxxxxxxxxxyyyyyyyyyyyyyyyy
 if.w d1 <ge> #525 and d1 <le> #567 then.l  ; if click inside Y range of buttons
        swap    d1                      d1=yyyyyyyyyyyyyyyyxxxxxxxxxxxxxxxx
   if.w d1 <ge> #10 and d1 <le> #139 then.l      new game button
        clr.l   d2
        clr.l   d7
        paintBoard
   else
     if.w d1 <ge> #661 and d1 <le> #790 then.l    exit button
        lea     exit,a1
        clr.l   d7
        move.b  why,d7
     endi
   endi
 endi
        move.l  (sp)+,d1                ; restore d1
        endm
        
findSquare macro
  
 if.w d3 <lt> #324 then.l
   move.w  #205,d3        
   if.w d4 <lt> #224 then.l      square 1
     move.w  #105,d4
     move.w  #0000,d5
   else    
     if.w d4 <lt> #374 then.l      square 4
       move.w  #255,d4
       move.w  #0003,d5
     else                          square 7
       move.w  #405,d4
       move.w  #0006,d5
     endi                        d4 <lt> #374
   endi                          d4 <lt> #224
 else                            
   if.w d3 <lt> #474 then.l
     move.w  #355,d3      
     if.w d4 <lt> #224 then.l      square 2
       move.w  #105,d4            
       move.w  #0001,d5
     else    
       if.w d4 <lt> #374 then.l      square 5
         move.w  #255,d4              
         move.w  #0004,d5
       else                          square 8
         move.w  #405,d4              
         move.w  #0007,d5
       endi                              d4 <lt> #374
     endi                                d4 <lt> #224
   else
     move.w  #505,d3                            
     if.w d4 <lt> #224 then.l      square 3
       move.w  #105,d4
       move.w  #0002,d5
     else    
       if.w d4 <lt> #374 then.l      square 6
         move.w  #255,d4
         move.w  #0005,d5
       else                            square 9
         move.w  #405,d4
         move.w  #0008,d5                
       endi                              d4 <lt> #374
     endi                                d4 <lt> #224
   endi                                  d3 <lt> #474
 endi                                    d3 <lt> #324
        
 endm 
     
swapChar        macro     
      if.b d6 <eq> oh then.l
        move.b  eks,d6
      else
        move.b  oh,d6
      endi
 
        lea     grid,a6                 ; point to grid
        mulu.w  #2,d5
        move.b  d6,(a6,d5.l)
        
        endm
         
placeXO macro
      if.b d6 <eq> eks then.l
        move.w  #eks,a1
      else
        move.w  #oh,a1
      endi
	move.l	#$00000000,d1 
        move.l  #$03400000,D2 
        move.b  #21,d0
        trap    #15     large font

        
       	move.w	d3,d1
	move.w	d4,d2
 	move.b  #95,d0  place X or O on screen
        trap    #15     
         
        move.b  #94,d0
        trap    #15     Repaint screen
 
        endm
        
checkWin        macro
        move.l  #red,d1
        move.b  #81,d0  
        trap    #15     Set fill color

        lea     grid,a6

      if.b d7 <ne> why then
        move.b  2(a6),d7        
        if.b d7 <ne> #blank then
          if.b d7 <eq> (a6) and.b d7 <eq> 4(a6) then                       75
            * winner                                                 1   |   |   6
            *                                                        7___|___|___2
            *                                                        5    224    5
            move.w  #175,d1                           
            move.w  #75,d2                          
            move.w  #625,d3                         
            move.w  #224,d4                   
            move.b  #87,d0                     
            trap    #15

	    move.w	d1,d3
	    move.w	d2,d4
            redoXO      d3,d4
            move.w  #325,d3
            move.w  #75,d4
            redoXO      d3,d4
            move.w  #475,d3
            move.w  #75,d4        
            redoXO      d3,d4
          
            move.b      why,d7
                               
          endi
        endi
      endi
      if.b d7 <ne> why then
         move.b  6(a6),d7                                   
        if.b d7 <ne> #blank then
          if.b d7 <eq> 8(a6) and.b d7 <eq> 10(a6) then                      224
            * winner                                                   1___|___|___6
            *                                                          7   |   |   2
            *                                                          5___|___|___5  
            move.w  #175,d1                                                 374  
            move.w  #224,d2                        
            move.w  #625,d3                        
            move.w  #374,d4                 
            move.b  #87,d0                   
            trap    #15

	    move.w	d1,d3
	    move.w	d2,d4
            redoXO      d3,d4
            move.w  #325,d3
            move.w  #224,d4
            redoXO      d3,d4
            move.w  #475,d3
            move.w  #224,d4       
            redoXO      d3,d4
          
            move.b      why,d7

          endi
        endi
      endi
      
      if.b d7 <ne> why then     
        move.b  12(a6),d7      
        if.b d7 <ne> #blank then
          if.b d7 <eq> 14(a6) and.b d7 <eq> 16(a6) then                1    374    6     
            *winner                                                    7___|___|___2
            *                                                          5   |   |   5
            *                                                               525
            move.w  #175,d1                       
            move.w  #374,d2                        
            move.w  #625,d3                        
            move.w  #525,d4                 
            move.b  #87,d0                   
            trap    #15
 
	    move.w	d1,d3
	    move.w	d2,d4           
            redoXO      d3,d4
            move.w  #325,d3                       
            move.w  #374,d4
            redoXO      d3,d4
            move.w  #475,d3                       
            move.w  #374,d4
            redoXO      d3,d4
          
            move.b      why,d7
          
          endi
        endi
      endi
       
      if.b d7 <ne> why then
        move.b  (a6),d7
        if.b d7 <ne> #blank then
          if.b d7 <eq> 6(a6) and.b d7 <eq> 12(a6) then                      75    
            *winner                                                       1__|3
            *                                                             7__|2
            *                                                             5  |4                 
            move.w  #175,d1                                                525
            move.w  #75,d2                        
            move.w  #324,d3                        
            move.w  #525,d4                 
            move.b  #87,d0                   
            trap    #15
              
	    move.w	d1,d3
	    move.w	d2,d4
            redoXO      d3,d4
            move.w  #175,d3
            move.w  #225,d4
            redoXO      d3,d4
            move.w  #175,d3
            move.w  #375,d4       
            redoXO      d3,d4
          
            move.b      why,d7

          endi
        endi
      endi
      
      if.b d7 <ne> why then
        move.b  2(a6),d7
        if.b d7 <ne> #blank then         
          if.b d7 <eq> 8(a6) and.b d7 <eq> 14(a6) then                      75
            *winner                                                      3|__|4   
            *                                                            2|__|7
            *                                                            4|  |4
            move.w  #324,d1                                                525
            move.w  #75,d2                        
            move.w  #474,d3                        
            move.w  #525,d4                 
            move.b  #87,d0                   
            trap    #15
                
	    move.w	d1,d3
	    move.w	d2,d4
            redoXO      d3,d4
            move.w  #324,d3
            move.w  #225,d4
            redoXO      d3,d4
            move.w  #324,d3
            move.w  #375,d4       
            redoXO      d3,d4
          
            move.b      why,d7

          endi
        endi
      endi

      if.b d7 <ne> why then
      move.b  4(a6),d7
        if.b d7 <ne> #blank then                 
          if.b d7 <eq> 10(a6) and.b d7 <eq> 16(a6) then                      75
            *winner                                                        4|__6
            *                                                              7|__2
            *                                                              4|  5
            move.w  #474,d1                                                 525
            move.w  #75,d2                        
            move.w  #625,d3                        
            move.w  #525,d4                 
            move.b  #87,d0                   
            trap    #15
                  
	    move.w	d1,d3
	    move.w	d2,d4
            redoXO      d3,d4
            move.w  #474,d3
            move.w  #225,d4
            redoXO      d3,d4
            move.w  #474,d3
            move.w  #375,d4       
            redoXO      d3,d4
          
            move.b      why,d7

          endi
        endi
      endi
      
      if.b d7 <ne> why then
      move.b  (a6),d7
        if.b d7 <ne> #blank then                              
          if.b d7 <eq> 8(a6) and.b d7 <eq> 16(a6) then                       75
            *winner                                                      1__|__   6
            *                                                            7  |__|__2
            *                                                            5     |  5
            move.w  #175,d1                                                  525
            move.w  #75,d2                        
            move.w  #324,d3                        
            move.w  #224,d4                 
            move.b  #87,d0                   
            trap    #15
	    move.w	d1,d3
	    move.w	d2,d4
            redoXO      d3,d4
            move.w  #324,d1                       
            move.w  #224,d2                        
            move.w  #474,d3                        
            move.w  #374,d4                 
            move.b  #87,d0                   
            trap    #15
	    move.w	d1,d3
	    move.w	d2,d4
            redoXO      d3,d4
            move.w  #474,d1                       
            move.w  #374,d2                        
            move.w  #625,d3                        
            move.w  #525,d4                 
            move.b  #87,d0                   
            trap    #15
	    move.w	d1,d3
	    move.w	d2,d4
            redoXO      d3,d4

            move.b      why,d7
          endi                      
        endi
      endi
      
      if.b d7 <ne> why then
        move.b  4(a6),d7
        if.b d7 <ne> #blank then
          if.b d7 <eq> 8(a6) and.b d7 <eq> 12(a6) then                      75
            *winner                                                    1   __|__6
            *                                                          7__|__|  2
            *                                                          5  |     5
            move.w  #474,d1                                                525                 
            move.w  #75,d2                        
            move.w  #625,d3                        
            move.w  #224,d4                 
            move.b  #87,d0                   
            trap    #15
	    move.w	d1,d3
	    move.w	d2,d4
            redoXO      d3,d4
            move.w  #324,d1                       
            move.w  #224,d2                        
            move.w  #474,d3                        
            move.w  #374,d4                 
            move.b  #87,d0                   
            trap    #15
	    move.w	d1,d3
	    move.w	d2,d4
            redoXO      d3,d4
            move.w  #175,d1                       
            move.w  #374,d2                        
            move.w  #324,d3                        
            move.w  #525,d4                 
            move.b  #87,d0                   
            trap    #15
	    move.w	d1,d3
	    move.w	d2,d4
            redoXO      d3,d4
          
            move.b      why,d7
          
          endi
        endi                        
      endi      

        move.l  #tan,d1
        move.b  #81,d0  
        trap    #15     Set fill color
                                
        endm

redoXO  macro
        move.w  \1,d3
        move.w  \2,d4
        findsquare      d3,d4
        placeXO d3,d4
        endm
        
tan     equ     216*$10000+233*$100+236
black   equ     $00000000
red     equ     $000000FF
blank   equ     $00000020
newgame dc.b    'New Game ',0
exit    dc.b    'Exit ',0
winmsg  dc.b    'You won! ',0
eks     dc.b    'X',0
oh      dc.b    'O',0
why     dc.b    'Y',0

grid    dc.b    ' ', ' ', ' '
        dc.b    ' ', ' ', ' '
        dc.b    ' ', ' ', ' '
        dc.b    ' ', ' ', ' '
        dc.b    ' ', ' ', ' '
        dc.b    ' ', ' ', ' '
        

START   move.b  #33,d0
        move.l  #800*$10000+600,D1
        trap    #15     change resolution

        lea     newgame,a1
        paintBoard       
  while.l a1 <ne> #exit do.l
    while.b d7 <ne> why do.l
        clr.l     d0
        clr.l     d1      
        move.b  #00,d1
        move.b  #61,d0
        trap    #15     read mouse      d1=yyyyyyyyyyyyyyyyxxxxxxxxxxxxxxxx
        checkButtons
      if.w d0 <eq> #01 then.l       left button down
 	    move.w	d1,d3
        swap    d1                      d1=xxxxxxxxxxxxxxxxyyyyyyyyyyyyyyyy
        move.w        d1,d4             d2=yyyyyyyyyyyyyyyy
        swap    d1                      d1=yyyyyyyyyyyyyyyyxxxxxxxxxxxxxxxx
        if.w d3 <gt> #174 and.w d3 <lt> #626 then.l
          if.w d4 <gt> #74 and.w d4 <lt> #526 then.l
            findSquare   d3,d4
            swapChar
            placeXO d3,d4           
            checkWin
            clr.l     d0
          endi                       d2 <gt> #74 and.w d2 <lt> #526 
        endi                         d1 <gt> #174 and.w d1 <lt> #626
        repeat                      ; wait for left button up
          move.l  #00,d1
          move.l  #61,d0
          trap    #15     read mouse      d1=yyyyyyyyyyyyyyyyxxxxxxxxxxxxxxxx
        until d0 <ne> #01 do        until left button up
        
      endi                           d0 <eq> #01          
    endw                                 d7 <ne> why
        
    if.b d7 <eq> why then.l
      while.b d6 <ne> #18 and.w (a1) <ne> #exit do.l        
        
        clr.l     d1
        lea     winmsg,a1       
        move.w  #200,d1
        move.w  #250,d2
        move.b  #95,d0              place win message on screen
        trap    #15
        move.l  #94,d0
        trap    #15                 ; repaint screen
        
        move.b  #00,d1
        move.b  #61,d0
        trap    #15     read mouse      d1=yyyyyyyyyyyyyyyyxxxxxxxxxxxxxxxx
        
        if.w d0 <eq> #01 then.l       left button down
          checkButtons
        endi                               d0 <eq> #01
      endw                               d2 <ne> #18 and.w (a1) <ne> #exit
    endi                                 d7 <eq> why
        clr.l  d7
  endw                                   a1 <ne> #exit
                
        MOVE.B  #9,D0
        TRAP    #15             Halt Simulator

* RAM
        END     START


21  Set font properties where:
    D1.L is color as 0x00BBGGRR
        BB is amount of blue from 0x00 to 0xFF
        GG is amount of green from 0x00 to 0xFF
        RR is amount of red from 0x00 to 0xFF
    D2.L
        Low word is style by bits 0 = off, 1 = on
            bit0 is Bold
            bit1 is Italic
            bit2 is Underline
            bit3 is StrikeOut
        High word (low byte) is Size in points (High word = 0, keep current font)
            8, 9, 10, 11, 12, 14, 16, 18 (not all sizes are valid for all fonts)
            Font sizes in multiples of valid sizes ( size * n) results in a scaled appearance. For example:
            in Fixedsys font sizes of 9*2, 9*3, ..9*n will result in larger characters but the characters will have
            pixelated edges.
        High word (high byte) is Font
            1 is Fixedsys (valid sizes: 9)
            2 is Courier (valid sizes: 10, 12, 15)
            3 is Courier New (valid sizes 8,9,10,11,12,14,16,18)
            4 is Lucida Console (valid sizes 8,9,10,11,12,14,16,18)
            5 is Lucida Sans Typewriter (valid sizes 8,9,10,11,12,14,16,18)
    Example: D2.L = $01090005 is Fixedsys, 9 point, Bold Underline
    

























*~Font name~Courier New~
*~Font size~10~
*~Tab type~1~
*~Tab size~4~
